/*
    Standard Main functions
*/
#ifdef WIN32
#include <conio.h>
#else
#include <unistd.h>
#include <errno.h>
#endif

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include "WinDef.h"
#include "llist.h"
#include "String.h"
#include "StringToArgv.h"
#include "StrConvert.h"


extern char Command[32], Par[20][64], Title[];
#ifdef WIN32
extern int  defaultDriver;
#endif
extern char defaultPath[256];
extern char WinDir[256];
#ifdef Encryption
	extern BOOL KeyMod;
	extern char LongKeyFile[256];
#endif
/*
   ErrorLevel = 0 Normal return
                1 location mismatch error
                2 Directive name error
                5 Search empty file error
*/
#define RegSize 20
int TimeFlag = 0, ErrorLevel = 0, Seed = 0;
double Register[RegSize], temp01;
int debug;

time_t ltime;
struct tm *today;

int RevRep, Log, Diff;

extern const char * Help_C[];
extern const char * Help_E[];
extern const char * Help_StrConvert[];
char Version[] = "-hk\n   Version 4.0.02, Copy Right by Pedro P. Wong 07/02/2014\n\
   EMail: pedrowong2001@yahoo.com.tw\n\
   Official Site: http://simpleauto.host-ed.me/home/\n\
                  http://simpleauto.byethost8.com/\n\
\n";

void Splitx(char * Msg, char * chrx);
void Get_Time();
void GetFormValue (char * , char * chrx);
int GetLineValue(char * msg);
#ifndef WIN32
void ParChk(char * msg);
#endif

/*
		Fix all message was changed as LowerChr.
*/
extern char argvx[argvsize][256];
extern int argvcnt;
struct llist * llist = NULL;

int main(int argc, char *argv[])
{

	/* int i, j, j1, X, Y,  */
	int i, j, j1, X, Y, z, Ex, XE, YE, fx,
		loopflg = 0, loopcnt, loopstep = 1, loopstart = 1;
	int i1, countx;

	FILE *fo = NULL;
	/* char c; */
	char buffer[1024], *Extract, tail[2], End[256], out[256];
	int  EFlag = 0,
		 ELoop = 0;	/* if set, Print until end string found. */
	struct llist_element *Srclist, *loop;
	struct llist *listSrc = NULL;


	/* If arguments error, exit */

	if (argc < 4) {
		/*
		printf("\n%s%s%s%s%s", Title, Help_E,
			Help1_E,Help2_E, Help3_E);
		*/
		/* puts(Title); */
		printf("\nExtract -->input parameter error.<--\n\n");
		printf("%s",Version);
		for(i=0; Help_E[i][0]; i++) {
			puts(Help_E[i]);
		}
		printf(">");
#ifdef WIN32
	  getch();
#else
	i = getc(stdin);
#endif
		/*
		printf("\n%s%s%s%s%s", Help_C, Help1_C,
			Help2_C, Help3_C, Version);
		*/
		printf("Chinese\n%s",Version);
		for(i=0; Help_C[i][0]; i++) {
			puts(Help_C[i]);
		}
		printf(">");
#ifdef WIN32
	  getch();
#else
	i = getc(stdin);
#endif

		printf("Special Characters in 'follow string' parameter were converted as:\n");
		for(i=0; Help_StrConvert[i][0]; i++) {
			puts(Help_StrConvert[i]);
		}
		printf(">");

		for (i=0;i<argc;i++) {
			if (argv[i][0]=='-' &&
				(argv[i][1]=='h' || argv[i][1]=='H') &&
				(argv[i][2]=='k' || argv[i][2]=='K')) {
				printf("\nExTract ExTract_File Script_File OutPut_File [-k|K:LongKeyName]\n");
				printf("ExTract ExTract_File -[XX]f|F|n|N:Compare-text [-[YY]x|X:Compare-text] \\\n");
				printf("          OutPut_File [-k|K:LongKeyName]\n>");
			}

		}

#ifdef WIN32
	  getch();
#else
	i = getc(stdin);
#endif
		exit(1);
	}


	/* Get default Dir. */
	GetDefault();
	/* Delete last '\' char. */
	i = strlen(defaultPath);
	if (defaultPath[i-1]=='\\')	defaultPath[i-1]=0x00;

	/*	Read in Input file, and save in llist */

	fo = NULL;
	/*	Allow run in no input file case.	*/
	if (argv[1][0]) {
#ifndef WIN32
		ParChk(argv[1]);
#endif
		llist = list_read(argv[1]);
		/* if (llist== NULL || llist->size == 0) goto ExitY; */
		if (llist== NULL) goto ExitY;
		if (llist->size <= 0) ErrorLevel = 5;
	}

    /*	Open output files */
	End[0] = 0;
	ELoop = 0;
	if (argv[2][0]=='-' && argv[3][0]=='-') {
		if (argc>4 && argv[4][0]) {
#ifndef WIN32
			ParChk(argv[4]);
#endif
			fo = fopen(argv[4], "wt");
#ifndef WIN32
			ParChk(argv[5]);
#endif
			if (argv[5]) {
				if (argv[5][0]=='-' &&
					(argv[5][1]=='k' || argv[5][0]=='K') &&
					argv[5][2]==':') {
#ifdef Encryption
					KeyMod = true;
					strcpy(LongKeyFile, argv[5]+3);
#endif
				}
			}
		}

		if ((argv[3][1]=='x' || argv[3][1]=='X') &&
			 argv[3][2]==':') {
#ifndef WIN32
			ParChk(argv[3]);
#endif
			strcpy (End, argv[3]+3);	/*  copy end string */
			EFlag = 1;					/*  Set end flag */
			Ex = -1;
		} else {
			j = strlen(argv[3]);
			X = 1;
			while (X<j && argv[3][X]!=':') X++;
			if (X!=j && (argv[3][X-1]=='x' || argv[3][X-1]=='X')) {
				X++;	/* skip 'x|X' and ':' */
			}
			/* set end string and compare column */
			Ex = atoi(argv[3]+1);
			if (Ex>0) Ex--;
			else if(Ex<0) Ex=0;
			strcpy (End, argv[3]+X);
			EFlag = 1;
		}
	} else {
#ifndef WIN32
		ParChk(argv[3]);
#endif
		fo = fopen(argv[3], "wt");
		EFlag = 0;

		/* Set Long Key parameter */
#ifdef Encryption
		if(argv[4]) {
#ifndef WIN32
			ParChk(argv[4]);
#endif
			if (argv[4][0]=='-' &&
				(argv[4][1]=='k' || argv[4][0]=='K') &&
				argv[4][2]==':') {
				KeyMod = true;
				strcpy(LongKeyFile, argv[4]+3);
			}
		}
#endif
	}
	/* if(fs==NULL || fo==NULL) { */
	if(fo==NULL) {
		fprintf (fo,", \n%s\nFile Open Error\n\n",argv[3]);
		goto ExitY;;
	}
	/* fprintf (fo, "default driver = >%d<\n", defaultDriver); */
	/* fprintf (fo, "default Path = >%s<\n", defaultPath); */

	/* Parameter 2 may have two format */
	/* one -[XX]f:sompare-text  */
	/* two script-file-name */

	/* type one */
	if (argv[2][0]=='-') { /* -f|F:string */
#ifndef WIN32
		ParChk(argv[2]);
#endif
		if (llist==NULL) {
			ErrorLevel = 5;
			fprintf (fo,"\nInput file empty Error\n\n");
			goto ExitY;
		};
		if (llist->size <= 0) {
			ErrorLevel = 5;
			fprintf (fo,"\nInput file empty Error\n\n");
			goto ExitY;
		}
		if ((argv[2][1]=='f' || argv[2][1]=='F' ||
			 argv[2][1]=='n' || argv[2][1]=='N') &&
			argv[2][2]==':') {
			for (i=1;i<=llist->size;i++) {
				Extract = GetLine(llist, i);
				if (Extract==NULL) {
					if (argv[2][1]=='n' || argv[2][1]=='N')
						fprintf (fo,"\n");
					continue;
				}
				/*
						End Mode
				*/
				/* Print until special string was found? */
				if (EFlag) {
					if (ELoop &&
						(argv[2][1]=='f' || argv[2][1]=='F'))
							fprintf (fo,"%s\n", Extract);
					YE = strlen(End);
					XE = strlen(Extract);
					if (YE>XE) continue;
					if (ELoop) {
						if (Ex!=-1) {
								if (strncmp(Extract+Ex, End, YE)==0) {
									ELoop = 0;
									goto Findnext;
								}
						} else {
							for (XE=0;XE<((int)strlen(Extract))-YE+1;XE++) {
								if (strncmp(Extract+XE, End, YE)==0) {
									ELoop = 0;
									goto Findnext;
								}
							}
						}
					}
				}
				/*
						Non End Mode
				*/
				if (strlen(Extract)==0) goto Find001;
				if (strlen(argv[2]+3)>strlen(Extract)) goto Find001;
				Y = strlen(argv[2]+3);
				for (X=0;X<((int)strlen(Extract))-Y+1;X++) {
					if (strncmp(Extract+X, argv[2]+3, Y)==0) {
						if (argv[2][1]=='f' || argv[2][1]=='F')
								fprintf (fo,"%s\n", Extract);
						if (EFlag) ELoop = 1;
						goto Findnext;
					}
				}	/* If not found and flag = 'n|N' than print out */
Find001:
				if (!ELoop && (argv[2][1]=='n' || argv[2][1]=='N'))
							fprintf (fo,"%s\n", Extract);
Findnext:;
			}
			goto ExitY;
		} else {	/*
						-XXf|F|n|N:string
					*/
			j = strlen(argv[2]);
			X = 1;
			while (X<j && argv[2][X]!=':') X++;
			if (X!=j && (argv[2][X-1]=='f' || argv[2][X-1]=='F' ||
				         argv[2][X-1]=='n' || argv[2][X-1]=='N')) {
				X++;	/* skip 'f|n' and ':' */
				/* X++; */
				j = atoi(argv[2]+1);
				if (j>0) j--;
				else if(j<0) j=0;
				Y = strlen(argv[2]+X);
				for (i=1;i<=llist->size;i++) {
					Extract = GetLine(llist, i);
					if (Extract==NULL) {
						if (argv[2][X-2]=='n' || argv[2][X-2]=='N')
							fprintf (fo,"\n");
						continue;
					}
					/*
							End Mode
					*/
					/* Print until special string was found? */
					if (EFlag) {
						if (ELoop &&
							(argv[2][X-2]=='f' || argv[2][X-2]=='F'))
								fprintf (fo,"%s\n", Extract);
						YE = strlen(End);
						XE = strlen(Extract);
						if (YE>XE) goto Find002;
						if (ELoop) {
							if (Ex!=-1) {
									if (strncmp(Extract+Ex, End, YE)==0) {
										ELoop = 0;
										goto Findnextx;
									}
							} else {
								for (XE=0;XE<((int)strlen(Extract))-YE+1;XE++) {
									if (strncmp(Extract+XE, End, YE)==0) {
										ELoop = 0;
										goto Findnextx;
									}
								}
							}
						}
					}
Find002:
					/*
							Non End Mode
					*/
					if (strlen(argv[2]+X)>strlen(Extract)) {
						if (argv[2][X-2]=='n' || argv[2][X-2]=='N')
								fprintf (fo,"%s\n", Extract);
						goto Findnextx;
					}
					if (strncmp(Extract+j, argv[2]+X, Y)==0) {
						if (EFlag) ELoop = 1;
						if (argv[2][X-2]=='f' || argv[2][X-2]=='F')
								fprintf (fo,"%s\n", Extract);
						else goto Findnextx;
					}
					if (!ELoop && (argv[2][X-2]=='n' || argv[2][X-2]=='N')) {
							fprintf (fo,"%s\n", Extract);
					}

Findnextx:;
				}
				goto ExitY;
			} else {	/* Format error */
				/*
				printf("\n%s%s%s%s%s", Title, Help_E,
					Help1_E,Help2_E, Help3_E);
				*/
				/* puts(Title); */
				printf("%s",Version);
				for(i=0; Help_E[i]; i++) {
					puts(Help_E[i]);
				}
				printf(">");
				i = getc(stdin);
				/*
				printf("\n%s%s%s%s%s", Help_C, Help1_C,
					Help2_C, Help3_C, Version);
				*/
				printf("%s",Version);
				for(i=0; Help_C[i]; i++) {
					puts(Help_C[i]);
				}
				printf(">");
				i = getc(stdin);
			}
		}
		goto ExitY;
	}
	/* type two script file name */
	/*	Read in script file */
#ifdef Encryption
	EncSetDefault();
#endif
	listSrc = list_read(argv[2]);
	if (listSrc== NULL || listSrc->size == 0) goto ExitY;


	i = 0;

	/* Initial Register */
	for (i=0;i<RegSize;i++) Register[i] = 0;

	/* process script list */
	Srclist = listSrc->head;
	while(Srclist) {
		/* if (ReadLine(fs, buffer, 256)) { */
		if (Srclist->ptr1==0) goto DoNext;;
		strcpy (buffer,  Srclist->ptr1);
		if (strlen(buffer)) {
			/*  LowerChrx(buffer); */
			countx = Parse(buffer);
ChkHere:
			LowerChrx(Command);
			if (Command[0]==0) goto DoNext;

			/* Find String [XX] [YY] [Z] [String] .. */
			if (strcmp(Command, "find") == 0) {	/* Find text and print out the line. */
				if (llist==NULL)  {
					ErrorLevel = 5;
					goto DoNext;
				}
				if (llist->size<=0) {
					ErrorLevel = 5;
					goto DoNext;
				}

				Y = strlen(Par[0]);
				if (Y==0) goto DoNext;

				if (Par[2][0]) {
					z = atoi(Par[2]);
					if (z<=0) z = 1;
				} else z = 1;

				for (i=1;i<=llist->size;i++) {
					Extract = GetLine(llist, i);
					if (Extract==NULL) continue;
					fx = 0;
CheckLoop:
                    Y = strlen(Par[0+fx]);
					if (Y==0) continue;
					if ((unsigned long)Y>strlen(Extract)) continue;

					if (strlen(Par[1])==0) {
						for (X=0;X<((int)strlen(Extract))-Y+1;X++) {
							if (strncmp(Extract+X, Par[0+fx], Y)==0) {
								/* fprintf (fo,"%s\n", Extract); */
								for (j=0;j<z;j++) {
									Extract = GetLine(llist, i+j);
									if (Par[3][0] && Extract) {
										if (j) fprintf (fo," ");
										fprintf (fo,"%s", Extract);
									} else {
										if (Extract) fprintf (fo,"%s\n", Extract);
										else fprintf (fo,"\n");
									}
								}
								if (Par[3][0]) fprintf (fo,"\n");
								goto FindLoop;
							}
						}
					} else {
						if (strncmp(Extract+atoi(Par[1])-1, Par[0+fx], Y)==0) {
								/* fprintf (fo,"%s\n", Extract); */
								for (j=0;j<z;j++) {
									Extract = GetLine(llist, i+j);
									if (Par[3][0] && Extract) {
										if (j) fprintf (fo," ");
										fprintf (fo,"%s", Extract);
									} else {
										if (Extract) fprintf (fo,"%s\n", Extract);
										else fprintf (fo,"\n");
									}
								}
								if (Par[3][0]) fprintf (fo,"\n");
								goto FindLoop;
						}
					}
					/* check end */
					if (fx==0) fx = 4;
					else ++fx;
					/*  more string to check? */
					if (countx>fx) goto CheckLoop;
FindLoop:;
				}
				goto DoNext;
			}


			/* MatchDump [-ALL] [-No] string1 string2 ...*/
			if (strcmp(Command, "matchdump") == 0) {	/* Find text and print out the line. */
				int All = 0, No = 0;
				if (llist==NULL)  {
					ErrorLevel = 5;
					goto DoNext;
				}
				if (llist->size<=0) {
					ErrorLevel = 5;
					goto DoNext;
				}

				Y = strlen(Par[0]);
				if (Y==0) goto DoNext;

				if (Par[0][0]=='-') {
					LowerChrx(Par[0]);
					if (strcmp(Par[0], "-all")==0) All = 1;
					else if (strcmp(Par[0], "-no")==0) No = 1;
					else {
						fprintf (fo,"%s\nExtract MatchDump parameter Error\n\n",buffer);
						ErrorLevel = 1;
						goto DoNext;
					}
				}

				if (Par[1][0]=='-') {
					LowerChrx(Par[1]);
					if (strcmp(Par[1], "-all")==0) All = 1;
					else if (strcmp(Par[1], "-no")==0) No = 1;
					else {
						fprintf (fo,"%s\nExtract MatchDump parameter Error\n\n",buffer);
						ErrorLevel = 1;
						goto DoNext;
					}
				}

				for (i=1;i<=llist->size;i++) {
					Extract = GetLine(llist, i);
					if (Extract==NULL) continue;
					if (All==1) {	/*  Match all string then dump */
						j = 1 + No;
						while (Par[j][0] && j<20) {
							if (strlen(Par[j])>strlen(Extract)) goto MatchDump02;
							Y = strlen(Par[j]);
							for (X=0;X<((int)strlen(Extract))-Y+1;X++) {
								if (strncmp(Extract+X, Par[j], Y)==0) {
									/*  string found then compare next string */
									goto MatchDump01X;
								}
							}
							/*  string not found then skip to next */
							goto MatchDump02;
MatchDump01X:
							j++;
						}
						if (No) fprintf (fo,"%i %s\n", i, Extract);
						else fprintf (fo,"%s\n", Extract);
					} else {	/*  Match one of the string then dump */
						j = No;
						while (Par[j][0] && j<20) {
							if (strlen(Par[j])>strlen(Extract)) goto MatchDump01;
							Y = strlen(Par[j]);
							for (X=0;X<((int)strlen(Extract))-Y+1;X++) {
								if (strncmp(Extract+X, Par[j], Y)==0) {
									fprintf (fo,"%s\n", Extract);
									/* break; */
									goto MatchDump02;
								}
							}
MatchDump01:
							j++;
						}
					}
MatchDump02:;
				}
				goto DoNext;
			}

			/* count */

			if (strcmp(Command, "count") == 0) {	/* Find text and print out the line. */
				if (llist==NULL)  {
					goto Zero00;
				}
				if (llist->size<=0) {
Zero00:
					if (Par[2][0]) {
						if (strcmp(Par[2], "\\n")==0) fprintf (fo,"0\n");
						else fprintf (fo,"0%s", Par[2]);
					} else fprintf (fo,"0");
					ErrorLevel = 5;
					goto DoNext;
				}

				Y = strlen(Par[0]);
				if (Y==0) goto DoNext;
				j = 0;

				for (i=1;i<=llist->size;i++) {
					Extract = GetLine(llist, i);
					if (Extract==NULL) continue;
					if (strlen(Par[0])>strlen(Extract)) continue;

					if (strlen(Par[1])==0) {
						for (X=0;X<((int)strlen(Extract))-Y+1;X++) {
							if (strncmp(Extract+X, Par[0], Y)==0) {
								j++;
								continue;
							}
						}
					} else {
						if (strncmp(Extract+atoi(Par[1])-1, Par[0], Y)==0) {
							j++;
						}
					}
				}
				if (Par[2][0]) {
					/*
					if (strcmp(Par[2], "\\n")==0) fprintf (fo,"%i\n", j);
					else fprintf (fo,"%i%s", j, Par[2]);
					*/
					StrConvert (Par[2],Par[2]);
					fprintf (fo,"%i%s", j, Par[2]);
				} else fprintf (fo,"%i", j);
				/*  Add to register(s) too */
				i = 3;
				while (i<21 && Par[i][0]) {
					X = atoi(Par[i]);
					if (X>0 && X<21) Register[X-1] += j;
					i++;
				}
				goto DoNext;
			}


			/* not */

			if (strcmp(Command, "not") == 0) {	/* Find text and print out the line. */
				if (llist==NULL)  {
					ErrorLevel = 5;
					goto DoNext;
				}
				if (llist->size<=0) {
					ErrorLevel = 5;
					goto DoNext;
				}

				if (Y==0) goto DoNext;

				if (Par[2][0]) {
					z = atoi(Par[2]);
					if (z<=0) z = 1;
				} else z = 1;

				j1 = atoi(Par[1]);

				for (i=1;i<=llist->size;i++) {
					Extract = GetLine(llist, i);
					if (Extract==NULL) goto NotNext;
					fx = 0;
CheckLoopX:
					Y = strlen(Par[0+fx]);
					if (Y==0) goto NotLoop;
					if ((unsigned long)Y>strlen(Extract)) goto NotNext;

					if (j1==0) {
						for (X=0;X<((int)strlen(Extract))-Y+1;X++) {
							if (strncmp(Extract+X, Par[0+fx], Y)==0) {
								/*  skip next line test also  01/12/2011 */
											i = i+z-1;
											goto NotNextx;
							}
						}
					} else {
						if (strncmp(Extract+j1-1, Par[0+fx], Y)==0) {
							/*  skip next line test also  01/12/2011 */
											i = i+z-1;
											goto NotNextx;
						}
          }
NotLoop:
					/*  check end */
					/* if (fx==0) fx = 4; */
					/*  no Z parameter now */
					if (fx==0) fx = 3;
					else fx++;
					/*  more string to check? */
					if (countx>fx) goto CheckLoopX;

NotNext:
					/* fprintf (fo,"%s\n", Extract);

						אּSɡACuL@

					for (j=0;j<z;j++) {
						Extract = GetLine(llist, i+j);
					*/
						Extract = GetLine(llist, i);
						/*
						if (Par[3][0] && Extract) {
							if (j) fprintf (fo," ");
							fprintf (fo,"%s", Extract);
						} else {
						*/
							if (Extract) fprintf (fo,"%s\n", Extract);
							else fprintf (fo,"\n");
						/* } */
					/* } */
					/* if (Par[3][0]) fprintf (fo,"\n"); */
NotNextx:;
				}
				goto DoNext;
			}

			/* WordRangeDump String1 String2 Word_No */
			if (strcmp(Command, "wordrangedump") == 0) {	/* Dump the line in word range */
				if (llist==NULL)  {
					ErrorLevel = 5;
					goto DoNext;
				}
				if (llist->size<=0) {
					ErrorLevel = 5;
					goto DoNext;
				}

				X = strlen(Par[0]);	/* first string size */
				if (X==0) goto DoNext;

				Y = strlen(Par[1]);	/* last string size */
				if (Y==0) goto DoNext;

				z = atoi(Par[2]);		/* word ID. */
				if (z) z--;

				for (i=1;i<=llist->size;i++) {
					StringToArgv(GetLine(llist, i));
					countx = argvcnt;
					if (countx == 0) continue;
					if ((z+1)>countx) continue;
					if (argvx[z]==NULL) continue;

					j = strncmp(argvx[z], Par[0], X);
					j = strncmp(argvx[z], Par[1], Y);

					if (strncmp(argvx[z], Par[0], X) <0 ||
					    strncmp(argvx[z], Par[1], Y) >0) continue;

					fprintf (fo,"%s\n", GetLine(llist, i));
				}
				goto DoNext;
			}


			/* StrRangeDump String1 String2 Column */
			if (strcmp(Command, "strrangedump") == 0) {	/* Dump the line in string range */
				if (llist==NULL)  {
					ErrorLevel = 5;
					goto DoNext;
				}
				if (llist->size<=0) {
					ErrorLevel = 5;
					goto DoNext;
				}

				X = strlen(Par[0]);	/* first string size */
				if (X==0) goto DoNext;

				Y = strlen(Par[1]);	/* last string size */
				if (Y==0) goto DoNext;

				z = atoi(Par[2]) - 1;	/* Column number */
				if (z<0) goto DoNext;

				for (i=1;i<=llist->size;i++) {

					Extract = GetLine(llist, i);
					if (Extract==NULL) continue;
					j = strlen(Extract);
					if (j<=(z+X)) continue;
					if (j<=(z+Y)) continue;

					if (strncmp(Extract+z, Par[0], X) <0 ||
					    strncmp(Extract+z, Par[1], Y) >0) continue;

					fprintf (fo,"%s\n", Extract);
				}
				goto DoNext;
			}

			/* loop */

			if (strcmp(Command, "loop") == 0) {	/* loop */
				if (!loopflg) {
					loop = Srclist;
					loopstart = 1;
					if (countx) {
						loopflg = atoi(Par[0]);
						if (loopflg<=0) loopflg = -1;
						if (Par[1][0]) loopstep = atoi(Par[1]);
						if (loopstep<=0) loopstep = 1;
					}
					else {
						loopflg = -1;
						loopstep = 1;
					}
					loopcnt = 0;
				}
				goto DoNext;
			}
			/* loopend */

			if (strcmp(Command, "loopend") == 0) {	/* Comment line with new line */
				if (loopflg) {
					loopcnt++;
					/* add one more line
					   to make sure end of file? */
					X = loopcnt * loopstep + loopstart;
					if (llist==NULL) {
						loopflg = 0;
						loopcnt = 0;
						goto DoNext;
					}
					if(loopcnt==loopflg ||
						X > llist->size) {
						loopflg = 0;
						loopcnt = 0;
						goto DoNext;
					}
					Srclist = loop;
				}
				goto DoNext;
			}

			/* comm1 */

			if (strcmp(Command, "comm1") == 0) {	/* Comment line with new line */
				fprintf (fo,"%s\n", Par[0]);
				goto DoNext;
			}
			/* comm2 */

			if (strcmp(Command, "comm2") == 0) {	/* Comment line w/o new line */
				fprintf (fo,"%s", Par[0]);
				goto DoNext;
			}
			/* extra0, extra1 */
			/*	Name with value; Extra1 name Line_No Column_No Data_Len */

			if (strcmp(Command, "extra0") == 0 ||
				strcmp(Command, "extra1") == 0 ) { /* Extract type 1 */
				if (llist==NULL)  {
					ErrorLevel = 5;
					goto DoNext;
				}
				if (llist->size<=0) {
					ErrorLevel = 5;
					goto DoNext;
				}

				/*  X = atoi(Par[1]); */
				X = GetLineValue(Par[1]);
				if (loopflg) {
					if (X > loopstart) loopstart = X;
					if (Par[4][0]) X += loopcnt*loopstep;
				}

				if (X > llist->size) {
Error01:
						fprintf (fo,"%s\nExtract Line No. %d Error\n\n",buffer,X);
						ErrorLevel = 1;
						goto DoNext;
				}
				Extract = GetLine(llist, X);
				if (Extract == NULL) {
					ErrorLevel = 1;
					goto Error01;
				}

				Y = atoi(Par[2]);
				if (Y) Y--;
				if ((unsigned)Y >= strlen(Extract)) {
						fprintf (fo,"%s\nExtract Column No. Error\n",buffer);
						ErrorLevel = 1;
						goto DoNext;
				}
				i = atoi(Par[3]);
				if ((unsigned)Y+i > strlen(Extract)) {
						fprintf (fo,"%s\nExtract Length. Error\n",buffer);
						ErrorLevel = 1;
						goto DoNext;
				}

				strncpy (out, Extract+Y, i);
				out[i] = 0;
				if (Par[5][0]) Splitx (out, Par[5]);

				if (strcmp(Command, "extra1") == 0 )
					/*
					if (i) {
						c = *(Extract+Y+i);
						*(Extract+Y+i) = 0;
						fprintf (fo,"%s %s\n", Par[0], Extract+Y);
						*(Extract+Y+i) = c;
					} else {
						fprintf (fo,"%s %s\n", Par[0], Extract+Y);
					}
					*/
					fprintf (fo,"%s %s\n", Par[0], out);
				else
					/*
					if (i) {
						c = *(Extract+Y+i);
						*(Extract+Y+i) = 0;
						fprintf (fo,"%s %s", Par[0], Extract+Y);
						*(Extract+Y+i) = c;
					} else {
						fprintf (fo,"%s %s", Par[0], Extract+Y);
					}
					*/
					fprintf (fo,"%s %s", Par[0], out);

				goto DoNext;
			}
			/* colum0, colum1 */
			/*	value w/o new line; Colum1 Line_No Column_No Data_Len */

			if (strcmp(Command, "colum0") == 0 ||
				strcmp(Command, "colum1") == 0) { /*  Colum type 1 */
				if (llist==NULL)  {
					ErrorLevel = 5;
					goto DoNext;
				}
				if (llist->size<=0) {
					ErrorLevel = 5;
					goto DoNext;
				}

				tail[0] = ',';
				tail[1] = '\0';
Colum101:
				/*  X = atoi(Par[0]); */
				X = GetLineValue(Par[0]);
				if (loopflg) {
					if (X > loopstart) loopstart = X;
					if (Par[3][0]) X += loopcnt*loopstep;
				}
				if (X > llist->size) {
Colum102:
						fprintf (fo,", %s\nExtract Line No. %d Error\n\n",buffer,X);
						ErrorLevel = 1;
						goto DoNext;
				}
				Extract = GetLine(llist, X);
				if (Extract == NULL) {
					ErrorLevel = 1;
					goto Colum102;
				}

				Y = atoi(Par[1]);
				if (Y) Y--;
				if ((unsigned)Y >= strlen(Extract)) {
						strcat(buffer, "\nExtract Column No. Error\n\n");
						fprintf (fo,", %s\n",buffer);
						ErrorLevel = 1;
						goto DoNext;
				}
				i = atoi(Par[2]);
				if ((unsigned)Y+i > strlen(Extract)) {
						/*
						strcat(buffer, "\nExtract Length. Error\n\n");
						fprintf (fo,", %s\n",buffer);
						ErrorLevel = 1;
						goto DoNext;
						*/
					    i = strlen(Extract) - Y + 1;
				}

				if (i) {
					strncpy (out, Extract+Y, i);
					out[i] = 0;
				} else strcpy (out, Extract+Y);
				if (Par[4][0]) Splitx (out, Par[4]);

				if (strcmp(Command, "colum1") == 0 ||
					strcmp(Command, "colum2") == 0) {
					/*
					if (i) {
						c = *(Extract+Y+i);
						*(Extract+Y+i) = 0;
						fprintf (fo,"%s%s", Extract+Y, tail);
						*(Extract+Y+i) = c;
					} else {
						fprintf (fo,"%s%s", Extract+Y, tail);
					}
					*/
					fprintf (fo,"%s%s", out, tail);
				} else {
					/*
					if (i) {
						c = *(Extract+Y+i);
						*(Extract+Y+i) = 0;
						fprintf (fo,"%s", Extract+Y);
						*(Extract+Y+i) = c;
					} else {
						fprintf (fo,"%s", Extract+Y);
					}
					*/
					fprintf (fo,"%s", out);
				}

				goto DoNext;
			}
			/* colum2
				value with Tab; Colum2 Line_No Column_No Data_Len
			*/
			if (strcmp(Command, "colum2") == 0) { /*  Colum type 2 */
				if (llist==NULL)  {
					ErrorLevel = 5;
					goto DoNext;
				}
				if (llist->size<=0) {
					ErrorLevel = 5;
					goto DoNext;
				}

				tail[0] = 9;
				tail[1] = '\0';
				goto Colum101;
			}
			/* colum3
				value with new line; Extra3 Line_No Column_No Data_Len
			*/
			if (strcmp(Command, "colum3") == 0) { /*  Colum type 3 */
				if (llist==NULL)  {
					ErrorLevel = 5;
					goto DoNext;
				}
				if (llist->size<=0) {
					ErrorLevel = 5;
					goto DoNext;
				}

				/*  X = atoi(Par[0]); */
				X = GetLineValue(Par[0]);
				if (loopflg) {
					if (X > loopstart) loopstart = X;
					if (Par[3][0]) X += loopcnt*loopstep;
				}

				if (X > llist->size) {
						/* strcat(buffer, "\nExtract Line No. Error\n\n"); */
Colum103:
						ErrorLevel = 1;
						fprintf (fo,", %s\nExtract Line No. %d Error\n\n",buffer,X);
						goto DoNext;
				}
				Extract = GetLine(llist, X);
				if (Extract == NULL) {
					ErrorLevel = 1;
					goto Colum103;
				}

				Y = atoi(Par[1]);
				if (Y) Y--;
				if ((unsigned)Y >= strlen(Extract)) {
						fprintf (fo,"%s\nExtract Column No. Error\n",buffer);
						ErrorLevel = 1;
						goto DoNext;
				}
				i = atoi(Par[2]);
				if ((unsigned)Y+i > strlen(Extract)) {
						/*
						fprintf (fo,"%s\nExtract Length. Error\n",buffer);
						ErrorLevel = 1;
						goto DoNext;
						*/
						i = strlen(Extract) - Y + 1;
				}

				if (i) {
					strncpy (out, Extract+Y, i);
					out[i] = 0;
				} else strcpy (out, Extract+Y);
				if (Par[4][0]) Splitx (out, Par[4]);

				/*
				if (i) {
					c = *(Extract+Y+i);
					*(Extract+Y+i) = 0;
					fprintf (fo,"%s\n", Extract+Y);
					*(Extract+Y+i) = c;
				} else
					fprintf (fo,"%s\n", Extract+Y);
				*/
				fprintf (fo,"%s\n", out);

				goto DoNext;
			}

			/* Line0, Line1 */
			/*	value w/o new line; LineX Line_No */

			if (strcmp(Command, "line0") == 0 ||
				strcmp(Command, "line1") == 0) { /*  Line type 1 */
				if (llist==NULL)  {
					ErrorLevel = 5;
					goto DoNext;
				}
				if (llist->size<=0) {
					ErrorLevel = 5;
					goto DoNext;
				}

				tail[0] = ',';
				tail[1] = '\0';
Line01:
				/*  X = atoi(Par[0]); */
				X = GetLineValue(Par[0]);
				if (loopflg) {
					if (X > loopstart) loopstart = X;
					if (Par[1][0]) X += loopcnt*loopstep;
				}
				if (X > llist->size) {
						fprintf (fo,", %s\nLineX Line No. %d Error\n\n",buffer,X);
						ErrorLevel = 1;
						goto DoNext;
				}
				Extract = GetLine(llist, X);
				if (Extract) {
					strcpy (out, Extract);
				} else out[0] = 0;

				if (strcmp(Command, "line1") == 0 ||
					strcmp(Command, "line2") == 0) {
					fprintf (fo,"%s%s", out, tail);
				} else {
					fprintf (fo,"%s", out);	/*  Line0 */
				}
				goto DoNext;
			}
			/* Line2
				value with Tab; Line2 Line_No
			*/
			if (strcmp(Command, "line2") == 0) { /*  Colum type 2 */
				if (llist==NULL)  {
					ErrorLevel = 5;
					goto DoNext;
				}
				if (llist->size<=0) {
					ErrorLevel = 5;
					goto DoNext;
				}

				tail[0] = 9;
				tail[1] = '\0';
				goto Line01;
			}
			/* Line3
				value with new line; Line3 Line_No
			*/
			if (strcmp(Command, "line3") == 0) { /*  Line type 3 */
				if (llist==NULL)  {
					ErrorLevel = 5;
					goto DoNext;
				}
				if (llist->size<=0) {
					ErrorLevel = 5;
					goto DoNext;
				}

				/*  X = atoi(Par[0]); */
				X = GetLineValue(Par[0]);
				if (loopflg) {
					if (X > loopstart) loopstart = X;
					if (Par[1][0]) X += loopcnt*loopstep;
				}

				if (X > llist->size) {
						/* strcat(buffer, "\nExtract Line No. Error\n\n); */
						ErrorLevel = 1;
						fprintf (fo,", %s\nExtract Line No. %d Error\n\n",buffer,X);
						goto DoNext;
				}

				Extract = GetLine(llist, X);
				if (Extract) {
					fprintf (fo,"%s%s\n", Extract, out);
				} else
					fprintf (fo,"%s\n", out);

				goto DoNext;
			}

			/* word0, word1
			   value with ','; Word1 Line_No Value_No
			*/
			if (strcmp(Command, "word0") == 0 ||
				strcmp(Command, "word1") == 0) { /* Word type 1 */
				if (llist==NULL)  {
					ErrorLevel = 5;
					goto DoNext;
				}
				if (llist->size<=0) {
					ErrorLevel = 5;
					goto DoNext;
				}

				tail[0] = ',';
				tail[1] = '\0';
Word101:
				/*  X = atoi(Par[0]); */
				X = GetLineValue(Par[0]);
				if (loopflg) {
					if (X > loopstart) loopstart = X;
					if (Par[2][0]) X += loopcnt*loopstep;
				}

				if (X > llist->size) {
Word102:
						/* strcat(buffer, "\nExtract Line No. Error\n\n"); */
						fprintf (fo,", %s\nExtract Line No. %d Error\n\n",buffer,X);
						ErrorLevel = 1;
						goto DoNext;
				}
				/* argvx = (char **) argv2D[X]; */
				StringToArgv(GetLine(llist, X));
				/*  fprintf(stderr, "Line no. = %d, argvcnt = %d.\n",X, argvcnt); */

				countx = argvcnt;
				if (countx == 0) goto Word102;

				Y = atoi(Par[1]);
				if (Y)Y--;
				if (Y <0 || Y >= countx) {
						strcat(buffer, "\nExtract Value No. Error\n\n");
						fprintf (fo,", %s\n",buffer);
						ErrorLevel = 1;
						goto DoNext;
				}

				if (argvx[Y]==NULL) out[0] = 0;
				else strcpy (out, argvx[Y]);
				if (Par[3][0]) {
					Splitx (out, Par[3]);
				}

				if (strcmp(Command, "word1") == 0 ||
					strcmp(Command, "word2") == 0)
					/* fprintf (fo, "%s%s", argvx[Y], tail); */
				    fprintf (fo, "%s%s", out, tail);
				else
					/* fprintf (fo, "%s", argvx[Y]); */
				    fprintf (fo, "%s", out);

				/*  add to register(s) too */
				i = 4;
				while (i<21 && Par[i][0]) {
					X = atoi(Par[i]);
					if (X>0 && X<21) Register[X-1] += atof(argvx[Y]);
					i++;
				}
				goto DoNext;
			}
			/* word2
			   value with TAB; Word2 Line_No Value_No
			*/
			if (strcmp(Command, "word2") == 0) { /*  Word2 type 2 */
				if (llist==NULL)  {
					ErrorLevel = 5;
					goto DoNext;
				}
				if (llist->size<=0) {
					ErrorLevel = 5;
					goto DoNext;
				}

				tail[0] = 9;
				tail[1] = '\0';
				goto Word101;
			}
			/* word3
			   value with new line; Word3 Line_No Value_No
			*/
			if (strcmp(Command, "word3") == 0) { /*  Word type 3 */
				if (llist==NULL)  {
					ErrorLevel = 5;
					goto DoNext;
				}
				if (llist->size<=0) {
					ErrorLevel = 5;
					goto DoNext;
				}

				/*  X = atoi(Par[0]); */
				X = GetLineValue(Par[0]);
				if (loopflg) {
					if (X > loopstart) loopstart = X;
					if (Par[2][0]) X += loopcnt*loopstep;
				}

				if (X > llist->size) {
						/* strcat(buffer, "\nExtract Line No. Error\n\n"); */
						fprintf (fo,", %s\nExtract Line No. %d Error\n\n",buffer,X);
						ErrorLevel = 1;
						goto DoNext;
				}
				StringToArgv(GetLine(llist, X));
				countx = argvcnt;
				if (countx == 0) {
						/* goto Error01; */
						strcat(buffer, "\nLine Empty error.\n\n");
						fprintf (fo,", %s\n",buffer);
						ErrorLevel = 1;
						goto DoNext;
				}

				Y = atoi(Par[1]);
				if (Y) Y--;

				if (Y <0 || Y >= countx) {
						Extract = GetLine(llist, X);
						strcat(buffer, "\nExtract Value No. Error\n\n");
						fprintf (fo,", %s\n",buffer);
						ErrorLevel = 1;
						goto DoNext;
				}

				if (argvx[Y]==NULL) out[0] = 0;
				else strcpy (out, argvx[Y]);
				if (Par[3][0]) {
					Splitx (out, Par[3]);
				}

				/* fprintf (fo, "%s\n", argvx[Y]); */
				fprintf (fo, "%s\n", out);
				/*  add to register(s) too */
				i = 4;
				while (i<21 && Par[i][0]) {
					X = atoi(Par[i]);
					if (X>0 && X<21) Register[X-1] += atof(argvx[Y]);
					i++;
				}
				goto DoNext;
			}
			/* copy
			   Copy number of lines; copy start_Line_No No_of_Lines
			*/
			if (strcmp(Command, "copy") == 0) {
				if (llist==NULL)  {
					ErrorLevel = 5;
					goto DoNext;
				}
				if (llist->size<=0) {
					ErrorLevel = 5;
					goto DoNext;
				}

				/*  X = atoi(Par[0]); */
				X = GetLineValue(Par[0]);
				if (loopflg && X > loopstart) loopstart = X;

				Y = atoi(Par[1]);
				if (Y<=0) Y = llist->size;
				else Y += X - 1;

				if (X > llist->size || Y> llist->size) {
						/* strcat(buffer, "\nExtract Line No. Error\n\n"); */
						fprintf (fo,", %s\nExtract Line No. %d Error\n\n",buffer,X);
						ErrorLevel = 1;
						goto DoNext;
				}

				for (j=X; j<=Y; j++) {
					Extract = GetLine(llist, j);
					if (Extract) fprintf (fo,"%s\n", Extract);
					else fprintf (fo,"\n");
				}
				goto DoNext;
			}
			/* copycsv, copycsvx
				Copy number of lines and output in Excel CSV format;
					 copy start_Line_No No_of_Lines
			*/
			if (strcmp(Command, "copycsv") == 0 ||
				strcmp(Command, "copycsvx") == 0) {
				if (llist==NULL)  {
					ErrorLevel = 5;
					goto DoNext;
				}
				if (llist->size<=0) {
					ErrorLevel = 5;
					goto DoNext;
				}

				/*  X = atoi(Par[0]); */
				X = GetLineValue(Par[0]);
				if (loopflg && X > loopstart) loopstart = X;
				Y = atoi(Par[1]);
				if (Y<=0) Y = llist->size;
				else Y += X - 1;

				if (X > llist->size || Y> llist->size) {
						/* strcat(buffer, "\nExtract Line No. Error\n\n"); */
						fprintf (fo,", %s\nExtract Line No. %d Error\n\n",buffer,X);
						ErrorLevel = 1;
						goto DoNext;
				}

				for (j1=X; j1<=Y; j1++) {
					/* argvx = (char **) argv2D[j1]; */
					StringToArgv(GetLine(llist, j1));

					countx = argvcnt;
					/* if ( countx==0) continue; */
					for (i1=0;i1<countx; i1++) {
						if (!i1) {
							if (strcmp(Command, "copycsv") == 0)
								fprintf (fo,"\"%s\"",argvx[i1]);
							else
								fprintf (fo,"\"%s ",argvx[i1]);
						}
						else {
							if (i1 == 1 &&
								strcmp(Command, "copycsvx") == 0)
								fprintf (fo,"%s\"",argvx[i1]);
							else
								fprintf (fo, ",\"%s\"",argvx[i1]);
						}
					}
					fprintf (fo,"\n");
				}

				goto DoNext;
			}
			/* copycsv90
				Copy number of lines and output in Excel CSV format
				with 90 degree X,Y convert.
					 copy start_Line_No No_of_Lines
			*/
			if (strcmp(Command, "copycsv90") == 0) {
				if (llist==NULL)  {
					ErrorLevel = 5;
					goto DoNext;
				}
				if (llist->size<=0) {
					ErrorLevel = 5;
					goto DoNext;
				}

				/* Read In parameters */
				/*  X = atoi(Par[0]); */
				X = GetLineValue(Par[0]);
				if (loopflg && X > loopstart) loopstart = X;
				Y = atoi(Par[1]);
				if (Y<=0) Y = llist->size;
				else Y += X - 1;

				if (X > llist->size || Y> llist->size) {
						/* strcat(buffer, "\nExtract Line No. Error\n\n"); */
						fprintf (fo,", %s\nExtract Line No. %d Error\n\n",buffer,X);
						ErrorLevel = 1;
						goto DoNext;
				}
				countx = 0;
				for (i=X;i<=Y;i++) {
					StringToArgv(GetLine(llist, i));
					if (countx ==0 || argvcnt >countx)
						countx = argvcnt;
				}

				/* write out data */
				for (i1=0;i1<countx; i1++) {
					for (i=X; i<=Y; i++) {
						StringToArgv(GetLine(llist, i));
						if (!argvcnt) {
							if (i==X) fprintf (fo,"\"\"");
							else fprintf (fo,",\"\"");
							continue;
						}
						if (i1>=argvcnt) {
							if (i==X) fprintf (fo,"\"\"");
							else fprintf (fo,",\"\"");
						} else {
							/* argvx = (char **) argv2D[i]; */
							if (i==X)
									if (argvx[i1]) fprintf (fo,"\"%s\"",argvx[i1]);
									else fprintf (fo,"\"\"");
							else
									if (argvx[i1]) fprintf (fo,",\"%s\"",argvx[i1]);
									else fprintf (fo,",\"\"");
						}

					}
					fprintf (fo,"\n");
				}
				goto DoNext;
			}
			/* htmltable
				Copy number of lines and output HTML Table format;
					 copy start_Line_No No_of_Lines
			*/
			if (strcmp(Command, "htmltable") == 0) {
				if (llist==NULL)  {
					ErrorLevel = 5;
					goto DoNext;
				}
				if (llist->size<=0) {
					ErrorLevel = 5;
					goto DoNext;
				}

				/* X = atoi(Par[0]); */
				X = GetLineValue(Par[0]);
				if (loopflg && X > loopstart) loopstart = X;
				Y = atoi(Par[1]);
				if (Y<=0) Y = llist->size;
				else Y += X - 1;

				if (X > llist->size || Y> llist->size) {
						/* strcat(buffer, "\nExtract Line No. Error\n\n"); */
						fprintf (fo,", %s\nExtract Line No. %d Error\n\n",buffer,X);
						ErrorLevel = 1;
						goto DoNext;
				}
				/* print Header first */
				fprintf (fo,"<body bgcolor=\"#FFDAB9\" text=\"#000000\">");
				fprintf (fo,"<center><table border=\"3\" cellpadding=\"2\" cellspacing=\"4\" >\n");
				for (j1=X; j1<=Y; j1++) {
					/* argvx = (char **) argv2D[j1]; */
					StringToArgv(GetLine(llist, j1));

					countx = argvcnt;
					if ( countx==0) continue;
					for (i1=0;i1<countx; i1++) {
							fprintf (fo,"<td align=\"center\">%s</td>",argvx[i1]);

					}
					fprintf (fo,"</tr>\n");
				}
				fprintf (fo,"</table></center></body>\n");
				goto DoNext;
			}
			/* matchlist */

			if (strcmp(Command, "matchlist") == 0) {	/* Match string */
				if (llist==NULL)  {
					ErrorLevel = 5;
					goto DoNext;
				}
				if (llist->size<=0) {
					ErrorLevel = 5;
					goto DoNext;
				}

				/* find out match string */
				i1 = 1;
Match00:
				X = strlen(Par[0]);
				if (Par[2][0]) {
					j = atoi(Par[2]);
					if (j>0) j--;
					else if(j<0) j = 0;
				} else j = 0;
				for (i=i1; i<=llist->size; i++) {
					Extract = GetLine(llist, i);
					if (Extract==NULL) continue;
					/*  strlen error. */
					Y = strlen(Extract);
					if (Y<X) continue;

					if (Par[2][0]) {
						if (*(Extract+j)!=Par[0][0]) continue;
						if (strncmp(Extract+j, Par[0], X)==0)
									 goto Match01;
					} else {
						for (j=0; j<(Y-X)+1; j++) {
							if (*(Extract+j)!=Par[0][0]) continue;
							if (strncmp(Extract+j, Par[0], X)==0)
									 goto Match01;
						}
					}
				}
				goto DoNext;
Match01:
				fprintf (fo,"%s\n", Extract);
				/*  No End string and No Loop flag? */
				if (!Par[1][0]) {
					if (!Par[4][0]) goto DoNext;
					else {
							i1 = i+1;
							goto Match00;
					}
				}

				X= strlen(Par[1]);
				if (Par[3][0]) {
					j = atoi(Par[3]);
					if (j>0) j--;
					else if(j<0) j = 0;
				} else j = 0;
Match02:
				i++;
				if (i>llist->size) goto DoNext;
				Extract = GetLine(llist, i);
				if (Extract==NULL) {
					fprintf (fo, "\n");
					goto Match02;
				} else fprintf (fo,"%s\n", Extract);
				Y = strlen(Extract);
				if (Y<X) goto Match02;
				if (Par[3][0]) {
					if (*(Extract+j)!=Par[1][0]) goto Match02;
					if (strncmp(Extract+j, Par[1], X)==0) {
						if (Par[4][0]) {
								i1 = i+1;
								goto Match00;
						} else goto DoNext;
					}
				} else {
					for (j=0; j<(Y-X)+1; j++) {
						if (*(Extract+j)!=Par[1][0]) continue;
					    if (strncmp(Extract+j, Par[1], X)==0) {
								if (Par[4][0]) {
										i1 = i+1;
										goto Match00;
								} else goto DoNext;
					   }
					}
				}
				goto Match02;
			}


			/* MatchDo string XX Command parameters*/

			if (strcmp(Command, "matchdo") == 0) {	/* Match-do string */
				int first = 1;		/*  Set flag for ListNo */
				if (llist==NULL)  {
					ErrorLevel = 5;
					goto DoNext;
				}
				if (llist->size<=0) {
					ErrorLevel = 5;
					goto DoNext;
				}

				/* find out match string */
				if (countx<3) goto DoNext;
				i1 = 1;

				X = strlen(Par[0]);
				if (Par[1][0] !='0') {
					j = atoi(Par[1]);
					if (j>0) j--;
					else if(j<0) j = 0;
				} else j = 0;
				if (debug) printf ("MatchDo compare >%s<\n", Par[0]);
MatchDo00:
				for (i=i1; i<=llist->size; i++) {
					Extract = GetLine(llist, i);
					if (Extract==NULL) continue;
					Y = strlen(Extract);
					if (Y<X) continue;

					if (Par[1][0]) {
						if (*(Extract+j)!=Par[0][0]) continue;
						if (debug) printf ("MatchDo compare location >%s<\n", Par[1]);
						if (strncmp(Extract+j, Par[0], X)==0)
									 goto MatchDo01;
					} else {
						for (j=0; j<(Y-X)+1; j++) {
							if (*(Extract+j)!=Par[0][0]) continue;
							if (strncmp(Extract+j, Par[0], X)==0)
									 goto MatchDo01;
						}
					}
				}
				if (debug) printf ("MatchDo not found\n");
				goto DoNext;
				/*
					Match found
                */
MatchDo01:
				LowerChrx(Par[2]);
				/*
					ListNo String1, String2, [L|l [x|X]]
				*/
				if (strcmp(Par[2], "listno") == 0) {
					if (first) {
						StrConvert(Par[3],Par[3]);
						StrConvert(Par[4],Par[4]);
					}
					/*  [x|X] flag set? */
					if ((Par[6][0]=='X' || Par[6][0]=='x') &&
						(Par[5][0]=='L' || Par[5][0]=='l')) {
						if (first) {
							fprintf (fo,"%d",i);
							first = 0;
						} else {
							fprintf (fo,"%s%s%d",Par[4],Par[3],i);
						}
					} else {
						fprintf (fo,"%s%d%s", Par[3],i,Par[4]);
						first = 0;
					}
					if (Par[5][0]=='L' || Par[5][0]=='l') {
						i1 = i + 1;
						if (i1<=llist->size) goto MatchDo00;
					}
					goto DoNext;
				}

				strcpy (Command, Par[2]);
				LowerChrx(Command);
				if (strncmp(Command, "comm", 4)==0) {
					for (i1=3;i1<20;i1++)
							strcpy (Par[i1-3], Par[i1]);
					Par[17][0] = 0;
					Par[18][0] = 0;
					Par[19][0] = 0;

					countx -= 3;
					if (debug) printf ("MatchDo found\n");
					goto ChkHere;
				}
				if (strncmp(Command, "register", 8)==0) {
					if (Par[3][0]=='w' || Par[3][0]=='W') {
						strcpy (Par[0], Par[3]);
						strcpy (Par[1], Par[4]);
						for (i1=5;i1<20;i1++)
								strcpy (Par[i1-2], Par[i1]);
						 Par[18][0] = 0;
						 Par[19][0] = 0;

						countx -= 2;
						/* save line no as first parameter */
						/* itoa(i, Par[2], 10); */
						sprintf(Par[2], "%d", i);
					} else {
						for (i1=3;i1<20;i1++)
								strcpy (Par[i1-3], Par[i1]);
						 Par[17][0] = 0;
						 Par[18][0] = 0;
						 Par[19][0] = 0;

						countx -= 3;
					}
					if (debug) printf ("MatchDo found\n");
					goto ChkHere;
				}
				if (strncmp(Command, "extra", 5)==0) {
					strcpy (Par[0], Par[3]);
					for (i1=4;i1<20;i1++)
							strcpy (Par[i1-2], Par[i1]);
					 Par[18][0] = 0;
					 Par[19][0] = 0;

					countx -= 2;
					/* save line no as first parameter */
						/* itoa(i, Par[1], 10); */
						sprintf(Par[1], "%d", i);
				} else {
					for (i1=2;i1<20;i1++)
							strcpy (Par[i1-2], Par[i1]);
					 Par[18][0] = 0;
					 Par[19][0] = 0;

					countx -= 2;
					/* save line no as first parameter */
						/* itoa(i, Par[0], 10); */
						sprintf(Par[0], "%d", i);
				}
				if (debug) printf ("MatchDo found\n");
				goto ChkHere;
			}

			/* WordMatchDo Line_No Word_No string Command parameters*/

			if (strcmp(Command, "wordmatchdo") == 0) {	/* Match-do string */
				if (llist==NULL)  {
					ErrorLevel = 5;
					goto DoNext;
				}
				if (llist->size<=0) {
					ErrorLevel = 5;
					goto DoNext;
				}

				/* find out match string */
				if (countx<4) goto DoNext;

				/* i = atoi(Par[0]);  *//* Line No. */
				i = GetLineValue(Par[0]); /* Line No. */
				j = atoi(Par[1]); /* Word No. */
				if (j) j--;

				if (debug) printf ("WordMatchDo compare >%s<\n", Par[0]);

				StringToArgv(GetLine(llist, i));

				countx = argvcnt;
				if ( countx<=j) goto DoNext;

				if (strcmp (Par[2], argvx[j])==0)
										goto WordMatchDo01;

				if (debug) printf ("WordMatchDo not found\n");
				goto DoNext;
				/*
					Match found
                */
WordMatchDo01:
				strcpy (Command, Par[3]);
				LowerChrx(Command);
				if (strncmp(Command, "comm", 4)==0 ||
					strncmp(Command, "loop", 4)==0 ||
					strncmp(Command, "year", 4)==0 ||
					strncmp(Command, "cyear", 5)==0 ||
					strncmp(Command, "month", 5)==0 ||
					strncmp(Command, "day", 3)==0 ||
					strncmp(Command, "hour", 4)==0 ||
					strncmp(Command, "minute", 6)==0 ||
					strncmp(Command, "copy", 4)==0) {
					for (i1=4;i1<20;i1++)
							strcpy (Par[i1-4], Par[i1]);

					Par[16][0] = 0;
					Par[17][0] = 0;
					Par[18][0] = 0;
					Par[19][0] = 0;

					countx -= 4;
					if (debug) printf ("WordMatchDo found\n");
					goto ChkHere;
				}
				if (strncmp(Command, "extra", 5)==0) {
					strcpy (Par[0], Par[4]);
					for (i1=5;i1<20;i1++)
							strcpy (Par[i1-3], Par[i1]);

					Par[17][0] = 0;
					Par[18][0] = 0;
					Par[19][0] = 0;

					countx -= 3;
						/* itoa(i, Par[1], 10); */
						sprintf(Par[1], "%d", i);
				} else {
					for (i1=4;i1<20;i1++)
							strcpy (Par[i1-3], Par[i1]);

					Par[17][0] = 0;
					Par[18][0] = 0;
					Par[19][0] = 0;

					countx -= 3;
					/* save line no as first parameter */
						/* itoa(i, Par[0], 10); */
						sprintf(Par[0], "%d", i);
				}
				if (debug) printf ("WordMatchDo found\n");
				goto ChkHere;
			}


			/* WordMatchDump Line_No Word_No */

			if (strcmp(Command, "wordmatchdump") == 0) {
				if (llist==NULL)  {
					ErrorLevel = 5;
					goto DoNext;
				}
				if (llist->size<=0) {
					ErrorLevel = 5;
					goto DoNext;
				}

				/* find out match string */

				/* i = atoi(Par[0]); */ /* Line No. */
				i = GetLineValue(Par[0]); /* Line No. */
				j = atoi(Par[1]); /* Word No. */
				if (j) j--;

				if (debug) printf ("WordMatchDump >%s<\n", Par[0]);

				StringToArgv(GetLine(llist, i));
				countx = argvcnt;
				if ( countx<=j) {
					ErrorLevel = 1;
					goto DoNext;
				}
				if (argvx[j][0]==0) {
					ErrorLevel = 1;
					goto DoNext;
				}

				strcpy (Par[2], argvx[j]);
				X = strlen(Par[2]);

				for (i=1; i<=llist->size; i++) {
					Extract = GetLine(llist, i);
					if (Extract==NULL) continue;
					Y = strlen(Extract);
					if (Y<X) continue;

					for (j=0; j<(Y-X)+1; j++) {
						if (*(Extract+j)!=Par[2][0]) continue;
						if (strncmp(Extract+j, Par[2], X)==0) {
								 fprintf(fo,"%s\n",Extract);
								 goto wordmatchdump01;
						}
					}
wordmatchdump01:
					continue;
				}
				goto DoNext;
			}

			/* WordMatchnotDump Line_No Word_No */

			if (strcmp(Command, "wordmatchnotdump") == 0) {
				if (llist==NULL)  {
					ErrorLevel = 5;
					goto DoNext;
				}
				if (llist->size<=0) {
					ErrorLevel = 5;
					goto DoNext;
				}

				/* find out match string */

				/* i = atoi(Par[0]);  *//* Line No. */
				i = GetLineValue(Par[0]); /* Line No. */
				j = atoi(Par[1]); /* Word No. */
				if (j) j--;

				if (debug) printf ("WordMatchnotDump >%s<\n", Par[0]);

				StringToArgv(GetLine(llist, i));
				countx = argvcnt;
				if ( countx<=j) {
					ErrorLevel = 1;
					goto DoNext;
				}
				if (argvx[j][0]==0) {
					ErrorLevel = 1;
					goto DoNext;
				}

				strcpy (Par[2], argvx[j]);
				X = strlen(Par[2]);

				for (i=1; i<=llist->size; i++) {
					Extract = GetLine(llist, i);
					if (Extract==NULL) continue;
					Y = strlen(Extract);
					if (Y<X) continue;

					for (j=0; j<(Y-X)+1; j++) {
						if (*(Extract+j)!=Par[2][0]) continue;
						if (strncmp(Extract+j, Par[2], X)==0) {
								 goto wordmatchnotdump01;
						}
					}
					fprintf(fo,"%s\n",Extract);
wordmatchnotdump01:
					continue;
				}
				goto DoNext;
			}

			/* year [shift-minute|*], [2|4], [follow] */

			if (strcmp(Command, "year") == 0) {	/* Match-do string */

				Get_Time();
				/*
				if (strcmp(Par[2],"\\n")==0)
					strcpy (Par[2], "\n");
				*/
				StrConvert (Par[2],Par[2]);
				if (Par[1][0]=='4' ||
					Par[1][0]==0) fprintf (fo,"%04d%s",today->tm_year+1900,Par[2]);
				else fprintf (fo,"%02d%s",(today->tm_year%100),Par[2]);

				goto DoNext;
			}

			/* cyear [shift-minute|*], [2|3], [follow]*/

			if (strcmp(Command, "cyear") == 0) {	/* Match-do string */

				Get_Time();
				/*
				if (strcmp(Par[2],"\\n")==0)
					strcpy (Par[2], "\n");
				*/
				StrConvert (Par[2],Par[2]);
				if (Par[1][0]=='2') fprintf (fo,"%02d%s",(today->tm_year-11)%100,Par[2]);
				else fprintf (fo,"%03d%s",today->tm_year-11,Par[2]);

				goto DoNext;
			}

			/* month [shift-minute|*], [follow] */

			if (strcmp(Command, "month") == 0) {	/* Match-do string */

				Get_Time();
				/*
				if (strcmp(Par[1],"\\n")==0)
					strcpy (Par[1], "\n");
				*/
				StrConvert (Par[1],Par[1]);
				fprintf (fo,"%02d%s",today->tm_mon+1,Par[1]);

				goto DoNext;
			}

			/* day [shift-minute|*], [follow] */

			if (strcmp(Command, "day") == 0) {	/* Match-do string */

				Get_Time();
				/*
				if (strcmp(Par[1],"\\n")==0)
					strcpy (Par[1], "\n");
				*/
				StrConvert (Par[1],Par[1]);
				fprintf (fo,"%02d%s",today->tm_mday,Par[1]);

				goto DoNext;
			}

			/* hour [shift-minute|*], [follow] */

			if (strcmp(Command, "hour") == 0) {	/* Match-do string */

				Get_Time();
				/*
				if (strcmp(Par[1],"\\n")==0)
					strcpy (Par[1], "\n");
				*/
				StrConvert (Par[1],Par[1]);
				fprintf (fo,"%02d%s",today->tm_hour,Par[1]);

				goto DoNext;
			}

			/* minute [shift-minute|*], [follow] [mod]*/

			if (strcmp(Command, "minute") == 0) {	/* Match-do string */

				Get_Time();
				/*
				if (strcmp(Par[1],"\\n")==0)
					strcpy (Par[1], "\n");
				*/
				StrConvert (Par[1],Par[1]);
				if (Par[2][0]) {
					if (Par[2][0]>='0' && Par[2][0]<='9') {
						i = today->tm_min % atoi(Par[2]);
						i = today->tm_min - i;
						fprintf (fo,"%02d%s",i,Par[1]);
					} else fprintf (fo,"%01d%s",(int)(today->tm_min/10),Par[1]);
				} else fprintf (fo,"%02d%s",today->tm_min,Par[1]);

				goto DoNext;
			}

			/* Value value-name [follow] */

			if (strcmp(Command, "value") == 0) {	/* Match-do string */
				if (llist==NULL)  {
					ErrorLevel = 5;
					goto DoNext;
				}
				if (llist->size<=0) {
					ErrorLevel = 5;
					goto DoNext;
				}

				X = strlen(Par[0]);
				for (i=0; i<=llist->size; i++) {
					Extract = GetLine(llist, i);
					if (Extract==NULL) continue;
					Y = strlen(Extract);
					if (Y<X) continue;
					for(j=0;j<Y-X;j++) {
						if (strncmp(Extract+j,Par[0],X)==0) {
							GetFormValue(Extract+j, (char *) Par[2]);
							/*
							if (strcmp(Par[1],"\\n")==0)
								strcpy (Par[1], "\n");
							*/
							StrConvert (Par[1],Par[1]);
							fprintf (fo,"%s%s",Par[2],Par[1]);
							goto DoNext;
						}
					}
				}

				fprintf (stderr," value >%s< not found error.\n",Par[0]);
				ErrorLevel = 1;
				goto DoNext;
			}


			/* Register Set|Inc|Dec|print ID [Value|String] [format]*/
			if (strcmp(Command, "register") == 0) {	/* Find text and print out the line. */
				LowerChrx(Par[0]);
				i = atoi(Par[1]) - 1;
				if (i<0 || i>=RegSize) {
					fprintf (fo,"-- register ID error -->%s<\n", Par[1]);
					goto DoNext;
				}
				if (strcmp(Par[0], "set") == 0) {
					Register[i] = atof(Par[2]);
					goto DoNext;
				}
				if (strcmp(Par[0], "add") == 0) {
					if (Par[2][0]) Register[i] += atof(Par[2]);
					else Register[i]++;
					goto DoNext;
				}
				if (strcmp(Par[0], "sub") == 0) {
					if (Par[2][0]) Register[i] -= atof(Par[2]);
					else Register[i]--;
					goto DoNext;
				}
				if (strcmp(Par[0], "mul") == 0) {
					if (Par[2][0]) {
						Register[i] *= atof(Par[2]);
					}
					goto DoNext;
				}
				if (strcmp(Par[0], "div") == 0) {
					temp01 = atof(Par[2]);
					if (Par[2][0]) {
						temp01 = atof(Par[2]);
						if (temp01 != 0.0) Register[i] /= temp01;
						else fprintf (fo,"-- Divide  register ID  by zero error.\n");					} else fprintf (fo,"-- Divide  register ID  by zero error.\n");
					goto DoNext;
				}
				/*	RAdd */
				if (strcmp(Par[0], "radd") == 0) {
					if (Par[2][0]) {
						j = atoi(Par[2])-1;
						if (j<0 || j>=RegSize) {
							fprintf (fo,"-- register IDX error -->%s<\n", Par[1]);
							goto DoNext;
						}
						Register[i] += Register[j];
					} else fprintf (fo,"-- No register IDX error.\n");;
					goto DoNext;
				}

				/*	RSub */
				if (strcmp(Par[0], "rsub") == 0) {
					if (Par[2][0]) {
						j = atoi(Par[2])-1;
						if (j<0 || j>=RegSize) {
							fprintf (fo,"-- register IDX error -->%s<\n", Par[1]);
							goto DoNext;
						}
						Register[i] -= Register[j];
					} else fprintf (fo,"-- No register IDX error.\n");;
					goto DoNext;
				}

				/*	RMul */
				if (strcmp(Par[0], "rmul") == 0) {
					if (Par[2][0]) {
						j = atoi(Par[2])-1;
						if (j<0 || j>=RegSize) {
							fprintf (fo,"-- register IDX error -->%s<\n", Par[1]);
							goto DoNext;
						}
						Register[i] *= Register[j];
					} else fprintf (fo,"-- No register IDX error.\n");;
					goto DoNext;
				}

				/*	RDiv */
				if (strcmp(Par[0], "rdiv") == 0) {
					if (Par[2][0]) {
						j = atoi(Par[2])-1;
						if (j<0 || j>=RegSize) {
							fprintf (fo,"-- register IDX error -->%s<\n", Par[1]);
							goto DoNext;
						}
						if (Register[j] != 0.0) Register[i] /= Register[j];
						else fprintf (fo,"-- Divide  register ID  by zero error.\n");
					} else fprintf (fo,"-- No register IDX error.\n");
					goto DoNext;
				}

				/*  WAdd */
				if (strcmp(Par[0], "wadd") == 0) {
					if (llist==NULL) {
						ErrorLevel = 5;
						goto DoNext;
					}
					if (llist->size<=0) {
						ErrorLevel = 5;
						goto DoNext;
					}
					X = atoi(Par[2]);
					if (loopflg) {
						if (X > loopstart) loopstart = X;
						if (Par[4][0]) X += loopcnt*loopstep;
					}
					if (X > llist->size) {
							/* strcat(buffer, "\nRegister WAdd Line No. Error\n\n"); */
WAdd101:
							fprintf (fo,", %s\nRegister WAdd Line No. %d Error\n\n",buffer,X);
							ErrorLevel = 1;
							goto DoNext;
					}
					/* argvx = (char **) argv2D[X]; */
					StringToArgv(GetLine(llist, X));

					countx = argvcnt;
					if (countx == 0) goto WAdd101;

					Y = atoi(Par[3]);
					if (Y)Y--;
					if (Y <0 || Y >= countx) {
							strcat(buffer, "\nRegister WAdd word No. Error\n\n");
							fprintf (fo,", %s\n",buffer);
							ErrorLevel = 1;
							goto DoNext;
					}

					if (argvx[Y][0]) Register[i] += atof(argvx[Y]);
					goto DoNext;
				}

				/*  wstrln		Add word string length */
				if (strcmp(Par[0], "wstrln") == 0) {
					if (llist==NULL) {
						ErrorLevel = 5;
						goto DoNext;
					}
					if (llist->size<=0) {
						ErrorLevel = 5;
						goto DoNext;
					}
					/*  X = atoi(Par[2]); */
					X = GetLineValue(Par[2]);
					if (loopflg) {
						if (X > loopstart) loopstart = X;
						if (Par[4][0]) X += loopcnt*loopstep;
					}
					if (X > llist->size) {
							/* strcat(buffer, "\nRegister WStrln Line No. Error\n\n"); */
WStrln101:
							fprintf (fo,", %s\nRegister WStrln Line No. %d Error\n\n",buffer,X);
							ErrorLevel = 1;
							goto DoNext;
					}
					/* argvx = (char **) argv2D[X]; */
					StringToArgv(GetLine(llist, X));

					countx = argvcnt;
					if (countx == 0) goto WStrln101;

					Y = atoi(Par[3]);
					if (Y)Y--;
					if (Y <0 || Y >= countx) {
							strcat(buffer, "\nRegister WStrln word No. Error\n\n");
							fprintf (fo,", %s\n",buffer);
							ErrorLevel = 1;
							goto DoNext;
					}

					if (argvx[Y][0]) Register[i] += strlen(argvx[Y]);
					goto DoNext;
				}

				/*  wsub */
				if (strcmp(Par[0], "wsub") == 0) {
					if (llist==NULL) {
						ErrorLevel = 5;
						goto DoNext;
					}
					if (llist->size<=0) {
						ErrorLevel = 5;
						goto DoNext;
					}
					X = atoi(Par[2]);
					if (loopflg) {
						if (X > loopstart) loopstart = X;
						if (Par[4][0]) X += loopcnt*loopstep;
					}
					if (X > llist->size) {
							/* strcat(buffer, "\nRegister WSub Line No. Error\n\n"); */
wsub101:
							fprintf (fo,", %s\nRegister WSub Line No. %d Error\n\n",buffer,X);
							ErrorLevel = 1;
							goto DoNext;
					}
					/* argvx = (char **) argv2D[X]; */
					StringToArgv(GetLine(llist, X));

					countx = argvcnt;
					if (countx == 0) goto wsub101;

					Y = atoi(Par[3]);
					if (Y)Y--;
					if (Y <0 || Y >= countx) {
							strcat(buffer, "\nRegister WSub word No. Error\n\n");
							fprintf (fo,", %s\n",buffer);
							ErrorLevel = 1;
							goto DoNext;
					}

					if (argvx[Y][0]) Register[i] -= atof(argvx[Y]);
					goto DoNext;
				}

				/*	WMul */
				if (strcmp(Par[0], "wmul") == 0) {
					if (llist==NULL) {
						ErrorLevel = 5;
						goto DoNext;
					}
					if (llist->size<=0) {
						ErrorLevel = 5;
						goto DoNext;
					}
					/*  X = atoi(Par[2]); */
					X = GetLineValue(Par[2]);
					if (loopflg) {
						if (X > loopstart) loopstart = X;
						if (Par[4][0]) X += loopcnt*loopstep;
					}
					if (X > llist->size) {
							/* strcat(buffer, "\nRegister wmul Line No. Error\n\n"); */
wmul101:
							fprintf (fo,", %s\nRegister wmul Line No. %d Error\n\n",buffer,X);
							ErrorLevel = 1;
							goto DoNext;
					}
					/* argvx = (char **) argv2D[X]; */
					StringToArgv(GetLine(llist, X));

					countx = argvcnt;
					if (countx == 0) goto wmul101;

					Y = atoi(Par[3]);
					if (Y)Y--;
					if (Y <0 || Y >= countx) {
							strcat(buffer, "\nRegister wmul word No. Error\n\n");
							fprintf (fo,", %s\n",buffer);
							ErrorLevel = 1;
							goto DoNext;
					}

					if (argvx[Y][0]) Register[i] *= atof(argvx[Y]);
					goto DoNext;
				}

				/*  WDiv */
				if (strcmp(Par[0], "wdiv") == 0) {
					if (llist==NULL) {
						ErrorLevel = 5;
						goto DoNext;
					}
					if (llist->size<=0) {
						ErrorLevel = 5;
						goto DoNext;
					}
					/*  X = atoi(Par[2]); */
					X = GetLineValue(Par[2]);
					if (loopflg) {
						if (X > loopstart) loopstart = X;
						if (Par[4][0]) X += loopcnt*loopstep;
					}
					if (X > llist->size) {
							/* strcat(buffer, "\nRegister wdiv Line No. Error\n\n"); */
wdiv101:
							fprintf (fo,", %s\nRegister wdiv Line No. %d Error\n\n",buffer,X);
							ErrorLevel = 1;
							goto DoNext;
					}
					/* argvx = (char **) argv2D[X]; */
					StringToArgv(GetLine(llist, X));

					countx = argvcnt;
					if (countx == 0) goto wdiv101;

					Y = atoi(Par[3]);
					if (Y)Y--;
					if (Y <0 || Y >= countx) {
							strcat(buffer, "\nRegister wdiv word No. Error\n\n");
							fprintf (fo,", %s\n",buffer);
							ErrorLevel = 1;
							goto DoNext;
					}

					if (argvx[Y][0]) {
						temp01 = atof(argvx[Y]);
						if (temp01 != 0.0) Register[i] /= temp01;
						else fprintf (fo,"-- Divide  register ID  by zero word error.\n");
					}
					goto DoNext;
				}

				/*  print */
				if (strcmp(Par[0], "print") == 0) {
					if (Par[3][0]) {	/*  Has Format */
						strcpy (buffer, Par[3]);
						/*
						if (Par[2][0]=='\\' || Par[2][1]=='n')
							strcat (buffer, "\n");
						else if (Par[2][0]) strcat (buffer, Par[2]);
						*/
						if (Par[2][0]) {
							StrConvert (Par[2],Par[2]);
							strcat (buffer, Par[2]);
						}
						if (!(Par[4][0]=='f' || Par[4][0]=='F'))
							fprintf (fo,buffer,(int)Register[i]);
						else
							fprintf (fo,buffer,Register[i]);
					} else {			/*  No Format */
						if (Par[2][0]) {
							 StrConvert (Par[2],Par[2]);
							 if (!(Par[4][0]=='f' || Par[4][0]=='F'))
								 fprintf (fo,"%d%s",(int)Register[i], Par[2]);
							 else fprintf (fo,"%.2f%s",Register[i], Par[2]);
						} else {
							if (!(Par[4][0]=='f' || Par[4][0]=='F'))
								fprintf (fo,"%d", (int)Register[i]);
							else
								fprintf (fo,"%.2f", Register[i]);
						}
					}
					goto DoNext;
				}
				fprintf (fo,"-- register function error -->%s<\n", Par[0]);
				goto DoNext;
			}

			/* Prompt [Prompt String] [follow String] */
			if (strcmp(Command, "prompt") == 0) {
				StrConvert (Par[0],Par[0]);
				StrConvert (Par[1],Par[1]);
				printf ("%s>",Par[0]);
				/* gets(buffer); */
				ReadLine(stdin, buffer, 1000);
				/*
				if (Par[1][0]=='\\' &&
				   (Par[1][1]=='n' || Par[1][1]=='N'))
					fprintf (fo,"%s\n",buffer);
				else fprintf (fo,"%s%s",buffer,Par[1]);
				*/
				fprintf (fo,"%s%s",buffer,Par[1]);
				goto DoNext;
			}

			/* Split String_for_split Split_command */

			if (strcmp(Command, "split") == 0) {

				if (debug) printf ("Split >%s<\n", Par[0]);

				strcpy (out, Par[0]);
				if (Par[1][0]) {
					Splitx (out, Par[1]);
				}
				fprintf (fo, "%s", out);
				goto DoNext;
			}

			/* DefPath Split_command */

			if (strcmp(Command, "defpath") == 0) {

				if (debug) printf ("Default Path >%s<\n", defaultPath);

				strcpy (out, defaultPath);
				if (Par[0][0]) {
					Splitx (out, Par[0]);
				}
				fprintf (fo, "%s", out);
				goto DoNext;
			}


			/* rand [RAND_MAX] [follow String] command */

			if (strcmp(Command, "rand") == 0) {
				if (!Seed) {
					Seed = 1;
					srand( (unsigned)time( NULL ) );
				}
				if (Par[0][0]) {
					Y = atoi(Par[0]);
					Y = rand() % Y;
				} else {
					Y = rand();
				}

				if (debug) printf ("Rand = >%d<\n", Y);

				if (Par[1][0]) {
					StrConvert (Par[1],Par[1]);
					fprintf (fo, "%d%s", Y, Par[1]);
				} else {
					fprintf (fo, "%d", Y);
				}
				goto DoNext;
			}


			/* NewSource filename */
			if (strcmp(Command, "newsource") == 0) {
				if(Par[0][0]==0) {
					fprintf (fo,"NewSource directive Error --> No input file name.\n");
					goto ExitY;
				}

				/*  Clear all buffer */

				/* Clear llist buffer */
				if (llist) llist_destroy(llist);

				/*  Read in new source file list */
				llist = list_read(Par[0]);
				/* if (llist== NULL || llist->size == 0) goto ExitY; */
				if (llist == NULL) {
					fprintf (fo,"NewSource directive Error --> No input file read error.\n");
					ErrorLevel = 5;
					goto ExitY;
				}
				if (llist->size <= 0) {
					fprintf (fo,"NewSource directive Error --> input file empty.\n");
					ErrorLevel = 5;
					goto ExitY;
				}

				/* construct data */
				goto DoNext;
			}

		ErrorLevel = 2;

		}
DoNext:
	Srclist = Srclist->next;
	}


ExitY:
#ifdef Gmem
	gmem_freeall();
#else
	if (llist) llist_destroy(llist);
#endif
	if (fo != NULL) fclose(fo);
    exit (ErrorLevel);
}


void Splitx(char * Msg, char * chrx)
{
	int i, j, len, x;

	len = strlen(Msg);
	if (!len) return;

	/* right to left */
	if (*chrx!='R' && *chrx!='r') goto Left001;
	for (i=len-1;i>=0;i--) {
		if (*(Msg+i) == *(chrx+1)) {
			if (*(chrx+2)!=0) {
				/*  j = atoi(chrx+2) + i; */
				j = atoi(chrx+2);
				/* if (*(chrx+2)!='-' || *chrx=='R') j++; */
				/*
				if (j>0|| (*chrx=='R' && j==0)) j=j+i+1;
				else j=j+i;
				*/
				/*
				j=j+i;
				if (j<0 || j> len) j = i;
				*/
				if (j<0) {
					j--;
					if (-j>len) j=-len;
				} else {
					if (j>len) j=len;
				}
			} else {
				/* j = i; */
				j = 0;
			}

			if (*chrx=='R') {
				/* if (*(chrx+2)=='0' && *(chrx+3)==0) strcpy (Msg, Msg+j); */
				/* else strcpy (Msg, Msg+j+1); */
				if (*(chrx+2)=='0' && *(chrx+3)==0) strcpy (Msg, Msg+i+j);
				else strcpy (Msg, Msg+i+j+1);
			} else {
				/*
				if (*(chrx+2)=='0' && *(chrx+3)==0) *(Msg+j+1) = 0;
				else *(Msg+j) = 0;

				if (*(chrx+2)=='0' && *(chrx+3)==0) *(Msg+j) = 0;
				else *(Msg+j+1) = 0;
				*/
				if (!j)j--;
				if (*(chrx+2)=='0' && *(chrx+3)==0) *(Msg+i+j+2) = 0;
				else *(Msg+i+j+1) = 0;
			}
			return;
		}
	}
	return;

Left001:
	/* left to right */
	if ((*chrx=='d' || *chrx=='D') ||
		(*chrx=='m' || *chrx=='M') ||
		(*chrx=='n' || *chrx=='N') ||
		(*chrx=='p' || *chrx=='P') ||
		(*chrx=='e' || *chrx=='E')) goto NameSplit;
	if (*chrx=='l' || *chrx=='L') x=1;
	else x = 0;
	for (i=0;i<len;i++) {
		if (*(Msg+i) == *(chrx+x)) {
			if (*(chrx+1+x)!=0) {
				/* j = atoi(chrx+1+x) + i; */
				j = atoi(chrx+1+x);
				/* if (*(chrx+1+x)!='-') j++; */

				/*
				if (j>0) j=j+i;
				else j=j+i-1;
				*/
				if (j<0) {
					j--;
					if (-j>len) j=-len;
				} else {
					if (j>len) j=len;
				}

				/* if (j<0 || j> len) j = i; */
			} else {
				/* j = i; */
				j = 0;
			}

			if (*chrx=='L') {
				/* if (*(chrx+1+x)=='0' && *(chrx+2+x)==0) strcpy (Msg, Msg+j+1); */
				if (*(chrx+1+x)=='0' && *(chrx+2+x)==0) strcpy (Msg, Msg+i+j);
				else {
					/* if (!j) j++; */
					/* strcpy (Msg, Msg+j+1); */
					strcpy (Msg, Msg+i+j+1);
				}
				/* if (*(chrx+1+x)=='0' && *(chrx+2+x)==0) strcpy (Msg, Msg+j+1); */
				/* else strcpy (Msg, Msg+j); */
			} else {
				/* if (*(chrx+1+x)=='0' && *(chrx+2+x)==0) *(Msg+j+2) = 0; */
				/*else *(Msg+j+1) = 0; */
				if (!j) j--;
				if (*(chrx+1+x)=='0' && *(chrx+2+x)==0) *(Msg+i+j+2) = 0;
				else *(Msg+i+j+1) = 0;
			}
			return;
		}
	}
NameSplit:
	switch(*(chrx)) {
		/* return device name */
		case 'd':
		case 'D':
			if (*(Msg+1)==':') *(Msg+2) = 0;
			else *(Msg) = 0;
			break;
		/* return short file name  with xtension */
		case 'm':
		case 'M':
		/* return short file name with out extension */
		case 'n':
		case 'N':
			i = len-1;
			while (i>=0) {
				if (*(Msg+i)=='\\' ||
					*(Msg+i)=='/') break;
				i--;
			}
			if (i>0) strcpy(Msg,Msg+i+1);
			if (*(chrx)=='m' || *(chrx)=='M') break;

			i = len-strlen(Msg);
			while (i>0) {
				if (*(Msg+i)=='.') break;
				i--;
			}
			if (i>0) *(Msg+i) = 0;
			break;
		/* return file extension name */
		case 'e':
		case 'E':
			i = len-1;
			while (i>=0) {
				if (*(Msg+i)=='.') break;
				i--;
			}
			if (i>=0) strcpy(Msg,Msg+i+1);
			else *(Msg) = 0;
			break;
		/* return short file name with out extension */
		case 'p':
		case 'P':
			i = len-1;
			while (i>=0) {
				if (*(Msg+i)=='\\' ||
					*(Msg+i)=='/') break;
				i--;
			}
			if (i>=0) *(Msg+i+1) = 0;
			else *(Msg) = 0;
			break;

		default:
			printf ("split function error --> \'%c\'\n", *(chrx));
			*(Msg) = 0;			/* fix crash on 2012/02/05 */
			break;
	}
	;
}

void Get_Time() {
	int shift;

	if (Par[0][0]=='*' && TimeFlag) goto Next001;
	if (Par[0][0]=='*' || Par[0][0]==0) shift = 0;
	else shift = 60 * atoi(Par[0]);
	time( &ltime );
	ltime += shift;
	TimeFlag = 1;
	today = localtime(&ltime);

Next001:
	return;
}

void GetFormValue (char * Msg, char * chrx) {
	int i,k,countx;

	countx = strlen(Msg);
	for (i=0;i<countx-6;i++) {
		if (strncmp(Msg+i,"value=",6)==0) {
			Msg = Msg+i+6;
			goto Next01;
		}
	}
	*chrx = 0;
	return;

Next01:
	if (*Msg=='"') {
		k=1;
		Msg++;
	} else {
		k=0;
	}

	for (i;i<countx;i++) {
		if (k && *Msg=='"') break;
		if (*Msg==' ' || *Msg=='>') break;
		*chrx++ = *Msg++;
	}

	*chrx = 0;
}

int GetLineValue(char * msg)
{
	int i;
	if (*msg=='l' || *msg=='L') {
		i = llist->size;
		if (*(msg+1)=='-' ) i += atoi(msg+1);
		return i;
	} else i = atoi(msg);
	if (i<1) i = 1;
	if (i>llist->size) i = llist->size;
	return i;
}

#ifndef WIN32
void ParChk(char * msg) {
  int i;

  if (msg==0) return;
  if (*msg==0) return;
  i = strlen(msg) - 1;
  if (*(msg+i) == 13) *(msg+i) = 0;
  return;
}
#endif
